
import java.net.*;
import java.io.*;
import java.util.regex.*;

public class NoFrillsHttpd {
	public static void main(String argv[]) throws IOException {
		ServerSocket ss = new ServerSocket(Integer.parseInt(argv[0]));
	while(true)
		new Thread(new NoFrillsHttpdConnection(ss.accept())).start();
	}
}


class NoFrillsHttpdConnection implements Runnable {
	Socket	client;

	NoFrillsHttpdConnection(Socket client) throws SocketException {
		this.client = client;
	}

	public void run() {
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream(), "8859_1"));
			OutputStream out = client.getOutputStream();
			PrintWriter pout = new PrintWriter(new OutputStreamWriter(out, "8859_1"), true);

			String request = in.readLine();
			System.out.println("RQ" + client.getLocalPort() + ": " + request + " from " + client.getInetAddress() + ":" + client.getPort());
			
			Matcher get = Pattern.compile("GET /?(\\S*).*").matcher(request);
			if (get.matches()) {
				request = get.group(1);
				if (request.matches("(\\S*)\\Q..\\E(\\S*)")) {
					System.out.println("Attempt to change up directories discarded");
				}
				else {
					String hostline;
					
					do {
						hostline = in.readLine();
					
						System.out.println(" HL: " + hostline);
					} while ((!hostline.startsWith("Host:")) && (hostline.length() > 1));
					
					if (hostline.endsWith("proto-logic.com"))
						request = "protologic/" + request;
					else if (hostline.endsWith("scartwright.net"))
						request = "scartwright/" + request;
						
					if (request.endsWith("/") || request.equals("") )
						request = request + "index.html";
						
					request = "/var/www/html/" + request;
					
					System.out.println("Serving " + request);
					
					try {
						FileInputStream fis = new FileInputStream(request);
						byte[] data = new byte[64*1024];
						for (int read; (read = fis.read(data)) > -1; ) out.write(data, 0, read);
						out.flush();
					}
					catch (FileNotFoundException e) {
						pout.println("404 Object Not Found");
					}
				}
			}
			else pout.println("400 Bad Request");
			
			client.close();
		}
		catch (IOException e) {
			System.out.println("I/O error " + e);
		}
		catch (Exception e) {
			System.out.println("Other error " + e);
		}
		
		System.out.println("<");
	}
}



